(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/operators'), require('rxjs'), require('@angular/material/select')) :
    typeof define === 'function' && define.amd ? define('ng-mat-select-infinite-scroll', ['exports', '@angular/core', 'rxjs/operators', 'rxjs', '@angular/material/select'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ng-mat-select-infinite-scroll"] = {}, global.ng.core, global.rxjs.operators, global.rxjs, global.ng.material.select));
})(this, (function (exports, i0, operators, rxjs, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    /** The height of the select items in `em` units. */
    var SELECT_ITEM_HEIGHT_EM = 3;
    var MatSelectInfiniteScrollDirective = /** @class */ (function () {
        function MatSelectInfiniteScrollDirective(matSelect, ngZone) {
            this.matSelect = matSelect;
            this.ngZone = ngZone;
            this.threshold = '15%';
            this.debounceTime = 150;
            this.infiniteScroll = new i0.EventEmitter();
            this.thrPx = 0;
            this.thrPc = 0;
            this.singleOptionHeight = SELECT_ITEM_HEIGHT_EM;
            this.destroyed$ = new rxjs.Subject();
        }
        MatSelectInfiniteScrollDirective.prototype.ngOnInit = function () {
            this.evaluateThreshold();
        };
        MatSelectInfiniteScrollDirective.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.matSelect.openedChange.pipe(operators.takeUntil(this.destroyed$)).subscribe(function (opened) {
                if (opened) {
                    _this.panel = _this.matSelect.panel.nativeElement;
                    _this.singleOptionHeight = _this.getSelectItemHeightPx();
                    _this.registerScrollListener();
                }
            });
        };
        MatSelectInfiniteScrollDirective.prototype.ngOnDestroy = function () {
            this.destroyed$.next(true);
            this.destroyed$.complete();
        };
        MatSelectInfiniteScrollDirective.prototype.evaluateThreshold = function () {
            if (this.threshold.lastIndexOf('%') > -1) {
                this.thrPx = 0;
                this.thrPc = (parseFloat(this.threshold) / 100);
            }
            else {
                this.thrPx = parseFloat(this.threshold);
                this.thrPc = 0;
            }
        };
        MatSelectInfiniteScrollDirective.prototype.registerScrollListener = function () {
            var _this = this;
            rxjs.fromEvent(this.panel, 'scroll').pipe(operators.takeUntil(this.destroyed$), operators.debounceTime(this.debounceTime), operators.tap(function (event) {
                _this.handleScrollEvent(event);
            })).subscribe();
        };
        MatSelectInfiniteScrollDirective.prototype.handleScrollEvent = function (event) {
            var _this = this;
            this.ngZone.runOutsideAngular(function () {
                if (_this.complete) {
                    return;
                }
                var countOfRenderedOptions = _this.matSelect.options.length;
                var infiniteScrollDistance = _this.singleOptionHeight * countOfRenderedOptions;
                var threshold = _this.thrPc !== 0 ? (infiniteScrollDistance * _this.thrPc) : _this.thrPx;
                var scrolledDistance = _this.panel.clientHeight + event.target.scrollTop;
                if ((scrolledDistance + threshold) >= infiniteScrollDistance) {
                    _this.ngZone.run(function () { return _this.infiniteScroll.emit(); });
                }
            });
        };
        MatSelectInfiniteScrollDirective.prototype.getSelectItemHeightPx = function () {
            return parseFloat(getComputedStyle(this.panel).fontSize) * SELECT_ITEM_HEIGHT_EM;
        };
        return MatSelectInfiniteScrollDirective;
    }());
    MatSelectInfiniteScrollDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: MatSelectInfiniteScrollDirective, deps: [{ token: i1__namespace.MatSelect }, { token: i0__namespace.NgZone }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    MatSelectInfiniteScrollDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MatSelectInfiniteScrollDirective, selector: "[msInfiniteScroll]", inputs: { threshold: "threshold", debounceTime: "debounceTime", complete: "complete" }, outputs: { infiniteScroll: "infiniteScroll" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: MatSelectInfiniteScrollDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[msInfiniteScroll]'
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.MatSelect }, { type: i0__namespace.NgZone }]; }, propDecorators: { threshold: [{
                    type: i0.Input
                }], debounceTime: [{
                    type: i0.Input
                }], complete: [{
                    type: i0.Input
                }], infiniteScroll: [{
                    type: i0.Output
                }] } });

    var MatSelectInfiniteScrollModule = /** @class */ (function () {
        function MatSelectInfiniteScrollModule() {
        }
        return MatSelectInfiniteScrollModule;
    }());
    MatSelectInfiniteScrollModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: MatSelectInfiniteScrollModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    MatSelectInfiniteScrollModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: MatSelectInfiniteScrollModule, declarations: [MatSelectInfiniteScrollDirective], imports: [i1.MatSelectModule], exports: [MatSelectInfiniteScrollDirective] });
    MatSelectInfiniteScrollModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: MatSelectInfiniteScrollModule, imports: [[
                i1.MatSelectModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: MatSelectInfiniteScrollModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [MatSelectInfiniteScrollDirective],
                        imports: [
                            i1.MatSelectModule
                        ],
                        exports: [MatSelectInfiniteScrollDirective]
                    }]
            }] });

    /*
     * Public API Surface of ng-mat-select-infinite-scroll
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.MatSelectInfiniteScrollDirective = MatSelectInfiniteScrollDirective;
    exports.MatSelectInfiniteScrollModule = MatSelectInfiniteScrollModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng-mat-select-infinite-scroll.umd.js.map
